<%@ Language=VBScript EnableSessionState=False %>
<%
  Response.Expires = 0
  LessonFile = Request.ServerVariables("SCRIPT_NAME")

  ScriptLanguagePreference = Request.Cookies("ScriptLanguagePreference")

  If ScriptLanguagePreference = "" Then
    ScriptLanguagePreference = Request.QueryString("ScriptLanguagePreference")
    If ScriptLanguagePreference = "" Then
      Response.Redirect "/iishelp/iis/htm/asp/iiselect.asp?LessonFile=" & Server.URLEncode(LessonFile)
    End If
  End If


'Determine the physical path for the current page and then remove the
'name of the file from the path (leaving just the directory).
MainPath = Request.ServerVariables("PATH_TRANSLATED")
Length = Len(MainPath)
i = 0
Do Until (i  = 2)
  Do While (Mid(MainPath, Length, 1) <> "\")
    Length = Length - 1      
  Loop  
i = i + 1
MainPath = left(MainPath, (Length-1)) 
Loop
FilePath = left(MainPath, Length) + "\tutorial"


'Determine the virtual path for the current page and then remove the
'name of the file from the path (leaving just the directory).
MainPath = Request.ServerVariables("PATH_INFO")
 
Length = Len(MainPath)
i = 0
Do Until (i  = 2)
  Do While (Mid(MainPath, Length, 1) <> "/")
    Length = Length - 1      
  Loop  
i = i + 1
MainPath = left(MainPath, (Length-1)) 
Loop
VirtFilePath = left(MainPath, Length) + "/tutorial"

%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html dir=ltr><head><title>Module 1: Creating ASP Pages</title>

<SCRIPT LANGUAGE="JavaScript">
<!--
	TempString = navigator.appVersion
	if (navigator.appName == "Microsoft Internet Explorer"){	
// Check to see if browser is Microsoft
		if (TempString.indexOf ("4.") >= 0){
// Check to see if it is IE 4
			document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/coua.css">');
		}
		else {
			document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/cocss.css">');
		}
	}
	else if (navigator.appName == "Netscape") {						
// Check to see if browser is Netscape
		document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/coua.css">');
	}
	else
		document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/cocss.css">');
//-->
</script> 

<SCRIPT LANGUAGE="VBScript">
<!--
Sub Window_OnLoad()
   Dim frmContents
   On Error Resume Next
   If Not Parent Is Nothing Then
      Set frmContents = Parent.Contents
      If Not frmContents Is Nothing Then
            frmContents.Window.TOCSynch_Click
      End If
   End If
End Sub
//--></SCRIPT>

<META NAME="DESCRIPTION" CONTENT="This is an Active Server Pages (ASP) tutorial where you can learn some ASP basics by creating your own ASP pages (.asp files)."><META HTTP-EQUIV="Content-Type" content="text/html; charset=Windows-1252"></head>

<body bgcolor="#FFFFFF" text="#000000"><font face="Verdana,Arial,Helvetica">


<h1><a name="module1">Module 1: Creating ASP Pages</a></h1>


<p><a href="iiselect.asp?LessonFile=<%= Server.URLEncode(LessonFile)%>"><strong>Choose a scripting language for this lesson.</strong></a></p>

<p>In this module, you will learn about ASP by creating your own ASP pages (.asp files). You will find the example files you are to use in these lessons in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory (<%=FilePath%>). Save the files you create in the Tutorial directory as well.</p>

<p><strong><a name="note"><span style="color: #0000FF"><font color="#0000FF">Important</font> </span></a></strong>&nbsp;&nbsp;&nbsp;To save and view your work in this module, you must enable Write and Script Web server permissions for the <%= VirtFilePath %> virtual directory on the <%= Request.ServerVariables("SERVER_NAME")%> Web server (with Active Server Pages installed).  For more information, see <a href="../core/iiwspsc.htm">Setting Web Server Permissions</a>.</p>

<hr>

<h2><a name="creatingasimpleactivexpage">Lesson 1: Creating a Simple ASP Page</a></h2>

<p>The best way to learn about ASP pages is to write your own. To create an ASP page, use a text editor to insert script commands into an HTML page. Saving the page with an .asp file name extension tells ASP to process the script commands. To view the results of a script, simply request the page in a Web browser by using the HTTP protocol, in this case http://<%= Request.ServerVariables("SERVER_NAME")%><%= VirtFilePath %>/<em>filename.asp</em>. In this lesson, you will create the popular &#147;Hello World!&#148; script by copying HTML and ASP scripting commands from this tutorial into a text editor. You can then view the script&#146;s output with your browser after you save the file in the text editor.</p>

<p>The following HTML creates a simple page with the words &#147;Hello World!&#148; in a large font:</p>

<pre>
&lt;HTML&gt;
  &lt;BODY&gt;
    &lt;FONT SIZE=7&gt; 
      Hello World!&lt;BR&gt; 
    &lt;/FONT&gt; 
  &lt;/BODY&gt;
&lt;/HTML&gt;</pre>

<p>Suppose you wanted to repeat this text several times, increasing the font size with each repetition. You could repeat the font tags and HTML text, giving it a different font size with each repetition. When a browser opens the HTML page, the line will be displayed several times.</p>

<p>Alternatively, you could use ASP to generate this same content in a more dynamic manner.</p>

<h3><a name="createandsaveapage">Create and Save a Page</a></h3>

<ol>
<li>Start a text editor (such as Notepad). Position the text editor window and the browser window so that you can see both.</li>
<li>Copy and paste the following HTML tags at the beginning of the file:</li>

<pre>&lt;%@ LANGUAGE=<%=ScriptLanguagePreference%> %&gt;
&lt;HTML&gt;
  &lt;BODY&gt; </pre>

<p>Notice that the very first tag is a special ASP tag that sets your default scripting language to <%=ScriptLanguagePreference%>.  Always be sure to add this tag as the first line of all your .asp files.</p>

<li>Save the document as Hello.asp in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory (<%=FilePath%>). Be sure to save the file in text format if you are using a word processor, including WordPad. ASP  pages must have the .asp extension to work properly.</li>

<p>If another user has previously created the Hello.asp file and completed this portion of the tutorial, replace the older version of Hello.asp with your newer version.</p>

<li>Start a new line after the <code>&lt;BODY&gt;</code> tag and copy and paste the following script command: 
<%
  If ScriptLanguagePreference = "JScript" Then
%>
<pre>&lt;%
    for (i = 3; i <=7;  i++)
    {
%&gt; </pre>


<%Else%>
<pre>&lt;% For i = 3 To 7 %&gt; </pre>



<% End If %><p>Script commands are enclosed within <code>&lt;%</code> and <code>%&gt;</code> characters (also called <em>delimiters</em>). Text within the delimiters is processed as a script command. Any text following the closing delimiter is simply displayed as HTML text in the browser. This script command begins a <%=ScriptLanguagePreference%> loop that controls the number of times the phrase "Hello World" is displayed. The first time through the loop, the counter variable (<code>i</code>) is set to 3. The second time the loop is repeated, the counter is set to 4. The loop is repeated until the counter <%
  If ScriptLanguagePreference = "JScript" Then
%>equals<%Else%>exceeds<% End If %> 7.</p>

<li>Press <STRONG>Enter</STRONG>, then copy and paste the following line: </li>

<pre>&lt;FONT SIZE=&lt;% = i %&gt;&gt; </pre>

<p>Each time through the loop, the font size is set to the current value of the counter variable (<code>i</code>). Thus, the first time the text is displayed, the font size is 3. The second time, the font size is 4. The last time, the font size is 7. Note that a script command can be enclosed within an HTML tag.</p>

<li>Press <STRONG>Enter</STRONG>, then copy and paste the following lines: </li>

<pre>  Hello World!&lt;BR&gt;
  &lt;/FONT&gt;
  <%  If ScriptLanguagePreference = "JScript" Then
%>&lt;% } %&gt;<%Else%>&lt;% Next %&gt;<% End If %>
  &lt;/BODY&gt;
&lt;/HTML&gt;</pre>

<p><%
  If ScriptLanguagePreference = "JScript" Then
%>The JScript curly braces ({ }) enclose the content repeated in the loop (as long as the counter is less than or equal to 7).<%Else%>The VBScript <strong>Next</strong> command repeats the loop (until the counter exceeds 7).<% End If %></p>



<li>The complete file (Hello.asp) should now contain the following text:</li>

<pre>
&lt;%@ LANGUAGE=<%=ScriptLanguagePreference%> %&gt;
&lt;HTML&gt;
  &lt;BODY&gt;
  <%
  If ScriptLanguagePreference = "JScript" Then
%>&lt;%
    for (i = 3; i <=7;  i++)
    {
  %&gt;<%Else%>&lt;% For i = 3 To 7 %&gt; <% End If %>
    &lt;FONT SIZE=&lt;% = i %&gt;&gt; 
    Hello World!&lt;BR&gt;
    &lt;/FONT&gt;
  <%  If ScriptLanguagePreference = "JScript" Then
%>&lt;% } %&gt;<%Else%>&lt;% Next %&gt;<% End If %>
  &lt;/BODY&gt;
&lt;/HTML&gt;</pre>


<li>Save your changes. Make sure to save your file in text format with an .asp extension.</li>

<p>Some text editors automatically change the file name extension to .txt when you choose <strong>Text Format </strong> in the <strong>Save</strong> dialog box. If this happens, replace the .txt extension with the .asp extension before you click <strong>Save</strong>.</p>


<li>Exit your text editor. A browser might not be able to request an HTML page that is open in a text editor.</li>

<li>To view the results of your work (after which you can return to this Tutorial by clicking the <STRONG>Back</STRONG> button in your browser), point your browser to <a href="http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/hello.asp"> http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/hello.asp</a>.</li>

<p>You should see a Web page with &#147;Hello World!&#148; displayed five times, each time in a larger font size.</p>


</ol>

<p>Congratulations! You have completed your first ASP page. As you have learned, the process of creating an ASP page is simple. You can use any text editor to create HTML content and ASP script commands (enclosed in <code>&lt;%</code> and <code>%&gt;</code> delimiters) as long as you give your files an .asp file name extension. To test a page and see the results, you request the page in a Web browser (or refresh a previously opened page).</p>

<hr>

<h2><a name="creatinganhtmlform">Lesson 2: Creating an HTML Form</a></h2>

<p>A common use of  intranet and Internet server applications is to process a form submitted by a browser. Previously, you needed to write a program to process the data submitted by the form. With ASP, you can embed scripts written in <%=ScriptLanguagePreference%> directly into an HTML file to process the form. ASP processes the script commands and returns the results to the browser.</p>

<p>In this lesson, you will create an ASP page that processes the data a user submits by way of an HTML form.</p>

<p>To see how the .asp file works, fill in the form below. You can use the <STRONG>Tab</STRONG> key to move around the form. Click the <strong><a name="script1">Submit </a></strong> button to send your data to the Web server and have it processed by ASP.</p>

<hr>
<!--  #include virtual="/iishelp/iis/htm/tutorial/script1.asp" -->


<h4><a name="H4_37672054">Create the Form</a></h4>

<p>We have created a form to request user information; you can find it in the file Form.htm in the Tutorial directory (<%= VirtFilePath%>):</p>

<pre>&lt;HTML&gt;
&lt;HEAD&gt;&lt;TITLE&gt;Order&lt;/TITLE&gt;&lt;/HEAD&gt;

  &lt;BODY&gt;
   &lt;H2&gt;Sample Order Form&lt;/H2&gt;
   &lt;P&gt;
   Please provide the following information, then click Submit:
		
   &lt;FORM METHOD="POST" ACTION="response.asp"&gt;
    &lt;P&gt;
    First Name: &lt;INPUT NAME="FirstName" SIZE="48"&gt;
    &lt;P&gt;
    Last Name: &lt;INPUT NAME="LastName" SIZE="48"&gt;
    &lt;P&gt;
    Title: &lt;INPUT NAME="Title" TYPE=RADIO VALUE="mr"&gt;Mr.
    &lt;INPUT NAME="Title" TYPE=RADIO VALUE="ms"&gt;Ms.
		
    &lt;P&gt;&lt;INPUT TYPE=SUBMIT VALUE="Submit"&gt;&lt;INPUT TYPE=RESET VALUE="Reset"&gt;
   &lt;/FORM&gt;

  &lt;/BODY&gt;

&lt;/HTML&gt;</pre>


<p>Like all HTML forms, this one sends the data to the Web server as pairs of variables and values. For example, the name the user types in the First Name text box is assigned to the variable named FirstName. ASP provides built-in objects that you can use to access the variable names and values submitted by a form.</p>

<h3><a name="createtheaspresponsepage">Create the ASP Response Page</a></h3>

<p>Now it's time to learn how a Web server processes the information it receives from an HTML form.  For this lesson we also have created an .asp file called Response.asp that will manipulate and display data received from Form.asp, that is, after you add a few extra script commands.</p>

<ol>
<li>Use your text editor to open the Response.asp file in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory (<%=FilePath%>).</li>

<li>Search for the words "<em>Define Scripting Language</em>," underneath this text line copy and paste the following line of script:</li>

<pre><&lt;%@ LANGUAGE=<%=ScriptLanguagePreference%> %&gt;</pre>

<p>Remember, always add this tag as the first script line in your .asp file so that the Web server knows what language you are using to write your script.</p>

<li>Now search for the words "<em>Tutorial Lesson</em>." Underneath this text line, copy and paste the following line of script:</li>

<%
  If ScriptLanguagePreference = "JScript" Then
%><pre>&lt;% 
  if (Request.Form("Title").Count == 1)
  {
    strTitle = Request.Form("Title")(1)
  }</pre>


<%Else%><pre>&lt;% 
  strTitle = Request.Form("Title") </pre>

<% End If %>

<p>If another user has previously completed this portion of the tutorial, this script command will already be in place underneath the "Tutorial Lesson" comment. Paste the copied script over the existing script, or copy an unused version of Response.asp from the Template directory to the Tutorial directory.</p>

<p>Your form submits three different variables or values to ASP:</p>

<ul>
<li><pre>FirstName</pre></li>
<li><pre>LastName</pre></li>
<li><pre>Title</pre></li>
</ul>

<p>ASP stores information submitted by way of HTML forms in the <strong>Forms</strong> collection of the <strong>Request</strong> object. To learn more about forms and objects, see <a href="iiwaform.htm">Processing User Input</a> and <a href="iiwaobb.htm">Built-in ASP Objects</a>.</p>

<p>To retrieve information from the <strong>Request</strong> object, your script needs to have the following syntax: 
Request.collection-name ("property-name"). Thus, Request.Form ("Title") retrieves <code>mr</code> or  <code>ms</code>, depending on the value the user submitted.</p>

</li>

<li>Copy and paste the following lines of script following the line you inserted in step&nbsp;3: </li>

<%
  If ScriptLanguagePreference = "JScript" Then
%><pre>  else
  {
    strTitle = ""
  }
  strLastName = Request.Form("LastName")
  if (strTitle == "mr")
    Response.Write("Mr. " + strLastName)
  else
  {
    if (strTitle == "ms")
      Response.Write("Ms. " + strLastName)
  </pre>



<%Else%><pre>  strLastName = Request.Form("LastName")
  If strTitle = "mr" Then 
  %&gt;  
  Mr. &lt;%= strLastName %&gt;  
  &lt;% ElseIf strTitle = "ms" Then %&gt; 
  Ms. &lt;%= strLastName %&gt; </pre>



<% End If %>

<p>If another user has previously completed this portion of the tutorial, these lines of script will already be in place. Paste the copied lines of script over the existing script, or copy an unused version of Response.asp from the Template subdirectory <%=FilePath%>\template to the Tutorial directory.</p>

<p>The <%=ScriptLanguagePreference%>&nbsp;<%
  If ScriptLanguagePreference = "JScript" Then
%><strong>if...else</strong>



<%Else%><strong>If...Then..Else</strong>



<% End If %> statement performs three different actions depending on the value of <code>strTitle</code>. If <code>strTitle</code> is <code>mr</code>, the user will be addressed as "Mr." If <code>strTitle</code> is <code>ms</code>, the user will be addressed as "Ms."   Otherwise, the first and last name will be used to address the user. You display the value of a variable by using the expression &lt;%= variable-name %&gt;.</p>

<li>To display both the first and last name if the user did not choose a title, copy and paste the following lines of script following the lines you inserted in Step&nbsp;3:</li>

<%
  If ScriptLanguagePreference = "JScript" Then
%><pre>    else
      Response.Write(Request.Form("FirstName") + " " + strLastName)
  }
%&gt; </pre>



<%Else%><pre>>&lt;% Else %&gt;
&lt;%= Request.Form("FirstName") &amp; " " &amp; strLastName %&gt;
&lt;% End If %&gt; </pre>



<% End If %>

<p>Again, if another user has previously completed this portion of the tutorial, these lines of script will already be in place. Paste the copied lines of script over the existing script, or copy an unused version of Response.asp from the Template subdirectory <%=FilePath%>\template to the Tutorial directory.<br>

<p>The <%
  If ScriptLanguagePreference = "JScript" Then
%>plus signs (<code>+</code>) join



<%Else%>ampersand (<code>&amp;</code>) joins


<% End If %> the values of the variables into one string. The <%
  If ScriptLanguagePreference = "JScript" Then
%>final <strong>}</strong> curly bracket



<%Else%><strong>End If statement</strong>



<% End If %> ends the conditional statement.</p>

</li>

<li>Save your changes to Response.asp and exit the text editor. Be sure your text editor does not replace the .asp file name extension.</li>

<li>To verify that the form you've created works (after which you can return to this tutorial by clicking the <STRONG>Back</STRONG> button in your browser), point your browser to <a href="http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/form.htm">http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/form.htm</a></li>

</ol>

<p>Congratulations! You have created your first HTML form for sending results to an .asp file. To learn about COM components, go on to <a href="iiatmd2.asp">Module&nbsp;2: Using COM Components</a>.</p>

<hr class="iis" size="1">
<p align=center><a href="/iishelp/common/colegal.htm"><em>&copy; 1997-1999 Microsoft Corporation. All rights reserved.</em></a></p>

</font>
</body>
</html>
