<%@ Language=VBScript EnableSessionState=False %>
<%
  Response.Buffer = True
  Response.Clear
  Response.Expires = 0  	

  LessonFile = Request.ServerVariables("SCRIPT_NAME")

  ScriptLanguagePreference = Request.Cookies("ScriptLanguagePreference")

 If ScriptLanguagePreference = "" Then
    ScriptLanguagePreference = Request.QueryString("ScriptLanguagePreference")
    If ScriptLanguagePreference = "" Then
      Response.Redirect "/iishelp/iis/htm/asp/iiselect.asp?LessonFile=" & Server.URLEncode(LessonFile)
    End If
  End If

'Determine the physical path for the current page and then remove the
'name of the file from the path (leaving just the directory).
MainPath = Request.ServerVariables("PATH_TRANSLATED")
Length = Len(MainPath)
i = 0
Do Until (i  = 2)
  Do While (Mid(MainPath, Length, 1) <> "\")
    Length = Length - 1      
  Loop  
i = i + 1
MainPath = left(MainPath, (Length-1)) 
Loop
FilePath = left(MainPath, Length) + "\tutorial"


'Determine the virtual path for the current page and then remove the
'name of the file from the path (leaving just the directory).
MainPath = Request.ServerVariables("PATH_INFO")
 
Length = Len(MainPath)
i = 0
Do Until (i  = 2)
  Do While (Mid(MainPath, Length, 1) <> "/")
    Length = Length - 1      
  Loop  
i = i + 1
MainPath = left(MainPath, (Length-1)) 
Loop
VirtFilePath = left(MainPath, Length) + "/Tutorial"


%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html dir=ltr><head><title>Module 2: Using COM Components</title>

<SCRIPT LANGUAGE="JavaScript">
<!--
	TempString = navigator.appVersion
	if (navigator.appName == "Microsoft Internet Explorer"){	
// Check to see if browser is Microsoft
		if (TempString.indexOf ("4.") >= 0){
// Check to see if it is IE 4
			document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/coua.css">');
		}
		else {
			document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/cocss.css">');
		}
	}
	else if (navigator.appName == "Netscape") {						
// Check to see if browser is Netscape
		document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/coua.css">');
	}
	else
		document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/cocss.css">');
//-->
</script> 


<SCRIPT LANGUAGE="VBScript">
<!--
Sub Window_OnLoad()
   Dim frmContents
   On Error Resume Next
   If Not Parent Is Nothing Then
      Set frmContents = Parent.Contents
      If Not frmContents Is Nothing Then
            frmContents.Window.TOCSynch_Click
      End If
   End If
End Sub
//--></SCRIPT>

<META NAME="DESCRIPTION" CONTENT="This is an Active Server Pages (ASP) tutorial where you can lean how to use COM components to extend your scripting capabilities. In this module, you will use COM components that are included with ASP to activate a sample Web site and query a database."><META HTTP-EQUIV="Content-Type" content="text/html; charset=Windows-1252"></head>

<body bgcolor="#FFFFFF" text="#000000"><font face="Verdana,Arial,Helvetica">



<h1><a name="module1">Module 2: Using COM Components</a></h1>

<p><a href="iiselect.asp?LessonFile=<%= Server.URLEncode(LessonFile) %>"><strong>Choose a scripting language for this lesson.</strong></a></p>


<p>COM <em>components</em> extend your scripting capabilities by providing a compact, reusable, and secure means of gaining access to information. For example, the Database Access component in ASP enables scripts to query databases. Thus, whenever you want to query a database from a script, you need not write complex scripts to perform this task. You can call components from any script or programming language that supports Automation (COM components are Automation servers). In this module, you will use COM components that are included with ASP to activate a sample Web site.</p>

<p>If you are not familiar with the basics of writing .asp files, complete <a href="iiatmd1.asp">Module 1</a> of this tutorial.</p>

<p><strong><a name="note"><span style="color: #0000FF"><font color="#0000FF">Important</a></font></span></strong></p>

<ul>
<li>To save and view your work in this module, you must enable Write and Script Web server permissions for the <%= VirtFilePath %> virtual directory on the <%= Request.ServerVariables("SERVER_NAME")%> Web server (with Active Server Pages installed).</li>

<li>Lesson 2 demonstrates a Dynamic HTML (DHTML) scriptlet.  This scriptlet displays a series of alternating ad images, dynamically transitioning between each image.  To run the scriptlet and see its effects you will need to use Internet Explorer&nbsp;version&nbsp;4.0, or later.  For more information about Internet Explorer, visit the Microsoft Web site at <a href="http://www.microsoft.com/isapi/redir.dll?prd=msft&ar=home"  target="_blank" >http://www.microsoft.com/</a>.</li>
</ul>

 <hr>

<h2><a name="H2_37665281"></a>Lesson 1: Using the Ad Rotator Component</h2>

<p>Internet Web sites often provide advertising space. To keep sites visually interesting and to display ads from several advertisers in limited space, you might want to cycle through different advertisements. The Ad Rotator component simplifies the task of displaying each ad in turn and makes it easier to add new ads.  Additionally, you can easily add or update the hyperlinks that enable users to click an ad and visit the advertiser's Web site.  In this lesson, you will create a script for that calls the Ad Rotator component to rotate through four randomly selected ads. Click the <STRONG>Show Me</STRONG> button below to see an example of an ad you are going to display, then click the button repeatedly to rotate through other <a name="usingtheadrotatorcomponent">ads</a>.<hr>
<!--#include virtual="/iishelp/iis/htm/tutorial/script4.asp" --></p>

<hr>

<h3><a name="createtheadfile">Create the Ad File</a></h3>

<p>We have created a Web page for a fictitious business, called Exotic Excursions, where you will insert the Ad Rotator script.  You can also create a simple text file to tell the Ad Rotator component which ads to insert and for what percentage of time each ad should be displayed. We have already created a file containing ads for you. To view it, use your text editor to open the file Adrot.txt in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory (<%= FilePath %>).</p>

<p>The first line of the file sets the script that will be called when a user clicks on an advertisement; in this case, Redirect.asp. You can modify the Redirect.asp file to perform a specific action, such as tracking ad popularity, prior to linking the user to the advertiser's Web site. The following three lines establish the width, height, and border of the ad images.</p>

<pre>redirect /iishelp/iis/htm/tutorial/redirect.asp
width 180
height 180
border 1</pre>


<p>Next, the file contains ad data. For each ad, this includes the image to use, the URL to go to when a user clicks the ad (in this case, after going to Redirect.asp), the text associated with the image, and the percentage of time this ad is to be displayed:</p>

<pre>/iishelp/iis/htm/tutorial/nyc.jpg
http://www.microsoft.com
Big Deals in the Big Apple
35</pre>


<p>By maintaining the ad information in a separate file, a different group at your organization can update the Adrot.txt file without requiring you to update your ASP page. Different groups can maintain different files of ads for different parts of your site.</p>

<h3><a name="createthescript">Create the Script</a></h3>

<ol>
<li>Use your text editor to open the file Exotic.asp in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory (<%= FilePath %>). 
<br><br></li>
  <li>At the top of Exotic.asp, before any other HTML tag or ASP instruction, paste the following line of script:</li>

<pre>&lt;%@ LANGUAGE=<%=ScriptLanguagePreference%> %&gt;</pre>
<p>This script is an ASP directive statement tells the Web server that your scripts are written in <%=ScriptLanguagePreference%>.  This directive statement must always be the first line of your ASP file.</p>

<li>Search for the words &#147;<em>Tutorial Lesson: Ad Rotator</em>.&#148; You will add your script here.</li>

<li>Create an instance of the Ad Rotator component and assign it to the variable <code>Ad</code> by copying the following script command and pasting it into your text editor (after the text line from the previous step):</li>

<pre>&lt;% <%
  If ScriptLanguagePreference = "JScript" Then

%><%Else%>Set<% End If %> Ad = Server.CreateObject("MSWC.Adrotator") %&gt; </pre>
<p>Assigning a component instance to a variable enables you to refer to a component later in a script.</p>

<p>If another user has previously completed this portion of the tutorial, this script command will already be in place. Paste the copied script over the existing script, or copy an unedited copy of Exotic.asp from the Template (<%=FilePath%>\template) directory to the Tutorial directory.</p>


<li>To display a new ad, you use the <strong>GetAdvertisement</strong> method of the Ad Rotator component. Add the following command to your script:</li>
<pre>&lt;%<%
  If ScriptLanguagePreference = "JScript" Then
%>Response.Write(Ad.GetAdvertisement("adrot2.txt"))<%Else%>= Ad.GetAdvertisement("adrot2.txt")<% End If %>%&gt; </pre>

<p>The <strong>GetAdvertisement</strong> method takes one parameter (the name of the file containing the ad information, in this case Adrot2.txt, which we've configured differently than Adrot.txt). On the basis of this parameter, the method returns a fully formatted HTML &lt;IMG&gt; tag with the appropriate ad. The variable name you assigned to the Ad Rotator component instance, <strong>Ad</strong>, precedes the method, <strong>GetAdvertisement</strong>, and the path for the file Adrot2.txt. The equal sign sends the value returned by the method (the actual ad) to the user's browser.</p>


<li>Save changes to Exotic.asp in text format and exit your text editor. Be sure your text editor does not replace the .asp file name extension.</li>

<li>To verify that the ASP page you&#146;ve created works (after which you can return to this tutorial by clicking Back in your browser), point your browser to
<a href="http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/exotic.asp">http://<%= Request.ServerVariables("SERVER_NAME")%>/IISHelp/IIS/Help/Htm/Tutorial/Exotic.asp</a>.</li>
</ol>

<hr>

<h2><a name="usingthebrowsercapabilitiescomponent">Lesson 2: Using the Browser Capabilities component</a></h2>

<p>Not all browsers support the broad range of today's Internet technologies. ActiveX Controls, streaming video, Dynamic HTML, and scriptlets are just some examples of features that some browsers support and others do not. Using ASP's Browser Capabilities component, you can design "intelligent" Web pages that present content in formats appropriate for the capabilities of the browser rendering your page. For example, you can design a Web page that uses the Browser Capabilities component to determine whether a user's browser supports an ActiveX-driven logo displayed on your page. If the browser does not, the logo will be displayed in an alternate form, such as static image.</p>

<p>In this lesson, you will enhance the Ad Rotator script you created in Lesson 1 to include script for activating a scriptlet.  scriptlets are simply Web pages containing scripts and HTML, which Web authors can create as reusable client-side objects. To include a scriptlet in a Web page, you only needs to insert an HTML &lt;OBJECT&gt; tag containing information about the type and location of the scriptlet.  In this lesson, the scriptlet you will be including in the Ad Rotator script uses Dynamic HTML (DHTML) to create an exciting ad rotator that transitions dynamically between images.</p>

<p>Currently, only Microsoft Internet Explorer&nbsp;version&nbsp;4.0, or later, supports scriptlets and certain DHTML features. This means that your Ad Rotator script must be able to detect the browser type. If a user&#146;s browser is Internet Explorer&nbsp;version&nbsp;4.0, or later, the user should see a set of ads that appear one after another, with a variety of dynamic transitions.  If the user's browser is not Internet Explorer&nbsp;version&nbsp;4.0, or later, then the user should see alternating static ads generated by the Ad Rotator component whenever the user refreshes the Web page.</p>

<p><a name="browscapdemo">Click</a> the <STRONG>Demonstrate</STRONG> button to see an example of a DHTML ad rotator generated by means of a scriptlet. (If your browser is not Microsoft Internet Explorer&nbsp;version&nbsp;4.0, or later, you will see the same static ads that you saw in <a href="#usingtheadrotatorcomponent">Lesson 1</a>.)</p>

<hr>
<CENTER>

<FORM  METHOD=POST ACTION="/iishelp/iis/htm/tutorial/DEMOROT.asp">
<INPUT TYPE=SUBMIT VALUE="Demonstrate">
</FORM>

</CENTER>
<hr>



<h3><a name="createthescriptb">Create the Script </a></h3>


<p><strong><span style="color: #0000FF"><font color="#0000FF">Important</font></span></strong>&nbsp;&nbsp;&nbsp;You must complete <a href="#usingtheadrotatorcomponent">Lesson 1</a> before doing this lesson.</p>

<ol>
<li>Start your text editor and open the file Exotic.asp in the Tutorial directory (<%= FilePath %>).</li>

<li>Search for the words &#147;Tutorial Lesson: Start Browser Capabilities.  Below this line of text add your script.</li>

<li>Create an instance of the Browser Capabilities component and assign it the variable <code>objBrowser</code> by copying the following script command and pasting it into Exotic.asp: <pre>&lt;% <%
  If ScriptLanguagePreference = "JScript" Then
%><%Else%>Set<% End If %> objBrowser = Server.CreateObject("MSWC.BrowserType") %&gt;</pre>

<p>If another user has previously completed this portion of the tutorial, these lines of script will already be in place. Paste the copied lines of script over the existing script, or copy an unused version of Exotic.asp from the Template subdirectory (<%=FilePath%>\template) to the Tutorial directory.</p>

<li>
<% If ScriptLanguagePreference = "JScript" Then %>
Use the JScript <strong>if...else</strong>
<% Else %>
Use the VBScript <strong>If...Then...Else</strong>
<% End If %>
 statement to determine whether or not a user's browser is Internet Explorer&nbsp;version&nbsp;4.0, or later. If it is, the scriptlet will be used; if the browser is not Internet Explorer&nbsp;version&nbsp;4.0, or later, and does not support scriptlets, the server-side Ad Rotator component will be used. To incorporate this logic, copy the following script and paste it after the <pre>&lt;%&nbsp;<%
  If ScriptLanguagePreference = "JScript" Then
%><%Else%>Set<% End If %>&nbsp;objBrowser...%&gt;</pre> 
statement you inserted in step 2: 
<pre>&lt;% <%
  If ScriptLanguagePreference = "JScript" Then
%>if (objBrowser.browser == "IE"   &&  objBrowser.majorver == "4") { <%Else%>If objBrowser.browser = "IE"  and  objBrowser.majorver >= 4  Then<% End If %>

%&gt;
&lt;OBJECT ID="scriptlet" 
		STYLE = "	position:relative;height:200;width:200"
        		TYPE  = "text/x-scriptlet"
		DATA = "..\tutorial\rotate5.htm"&gt;
&lt;/OBJECT&gt;

&lt;% <%
  If ScriptLanguagePreference = "JScript" Then
%> }
  else {<%Else%>Else<% End If %> %&gt; </pre>


<p>If another user has previously completed this portion of the tutorial, these lines of script will already be in place. Paste the copied script over the existing script, or copy an unused version of Exotic.asp from the Template subdirectory (<%=FilePath%>\template) to the Tutorial directory.</p>

<p>The Browser Capabilities component&#146;s <strong>browser</strong> and <strong>majorver</strong> properties determine whether the browser is Internet Explorer&nbsp;version&nbsp;4.0, or later.  The script uses the HTML <code>&lt;OBJECT&gt;</code>< tag to insert a scriptlet into the Web page. The tag's attributes specify the scriptlet's type (x-scriptlet), location, and dimensions. The actual scriptlet source file is called Rotate5.htm.  If you are interested, it's also located in the Tutorial directory (<%=FilePath%>).  You can open it with Notepad or with any HTML editing tool.</p>

</li>

<li>Search for the words &#147;<em>Tutorial Lesson - End Browser Capabilities</em>.&#148; Below this text line, copy and paste the following script command to end the 
<strong><%
  If ScriptLanguagePreference = "JScript" Then
%>if<%Else%>If...Then...Else<% End If %></strong> statement: 

<pre>&lt;%<%
  If ScriptLanguagePreference = "JScript" Then
%>
}
<%Else%> End If <% End If %>%&gt; </pre>

<p>If another user has previously completed this portion of the tutorial, this script command will already be in place. Paste the copied script over the existing script, or copy an unused version of Exotic.asp from the Template subdirectory (<%=FilePath%>\template) to the tutorial directory.</p>
</li>

<li>Save changes to Exotic.asp as a text file and exit your text editor. Be sure your text editor does not replace the .asp file name extension.</li>

<li>To verify that the ASP page you&#146;ve created works (after which you can return to this Tutorial by clicking Back in your browser), point your browser to <a href="http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/exotic.asp">http://<%= Request.ServerVariables("SERVER_NAME")%>/IISHelp/IIS/Help/Htm/Tutorial/Exotic.asp. </a></li>
</ol>

<p><strong>Note</strong>&nbsp;&nbsp;&nbsp; The file Browscap.ini (placed in Winnt\System32\Inetsrv by default) contains the data necessary for the Browser Capabilities component to recognize a browser and its capabilities. You will need to add new data to this file as new browsers are developed, or if you are using browser-dependent features that are not listed in the default Browscap.ini file.</p>

<hr>

<h2><a name="usingthedatabaseaccesscomponent">Lesson 3: Using the Database Access Component</a></h2>

<p>The ASP Database Access component uses ActiveX Data Objects (ADO) to provide easy access to information stored in OLE DB compliant data sources. OLE DB is a system-level programming interface that you can use to connect a variety of data sources, including databases, spreadsheets, or other sequential files. OLE DB defines a set of standard COM interfaces that expose database management system functionality. By providing easy access to these COM interfaces, ADO enables you to add database access to your Web applications using scripting languages, such as VBScript or JScript.</P>


<P>In this lesson, you will use ADO and OLE DB to query a Microsoft&#174; Access database file, return a set of records, and then display this information as an HTML table.  To preview this functionality, click the <STRONG>Show Me</STRONG> button:</p>

<hr>
<!--#include virtual="/iishelp/iis/htm/tutorial/script6.asp" -->
<hr>

<h3><a name="identifythedatabase">Identify the Database</a></h3>

<p>This first step in creating an ADO database script is to specify the correct <EM>connection string</EM> for your data source.  The connection string contains a series of semicolon delimited arguments that define parameters, such as the data source driver software and the location of the database file. For this lesson, we'll be accessing a Microsoft&#174; Access database file, called EECustmr.mdb, provided with this tutorial.</p>

<ol>

<li>Use your text editor to open the file Database.asp in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory ( <%= FilePath %>).</li>

<li>Search for the words "<em>Define Scripting Language</em>," underneath this text line, copy and paste the following line of script: </li>

<pre>&lt;%@ LANGUAGE=<%=ScriptLanguagePreference%> %&gt;</pre>
<p>Always be sure to add this tag as the first script line in all of your .asp files.</p>

<li>Search for the words &#147;<em>Tutorial Lesson - ADO Connection</em>,&#148; underneath this text line you will copy and paste your script.</li>
<li>Copy and paste the following statements:</li>

<pre>&lt;%
  strDBVirtualPath = "/iishelp/iis/htm/tutorial/EECustmr.mdb"
  strDBLocation = Server.Mappath(strDBVirtualPath)
  
<% If ScriptLanguagePreference = "JScript" Then %>
  strSource = "Provider=Microsoft.Jet.OLEDB.3.51;Data Source=" + strDBLocation<% Else%>  strSource = "Provider=Microsoft.Jet.OLEDB.3.51;Data Source=" & strDBLocation<% End If %></pre>

<P>The first two statements define the location of the sample database.  We use the <STRONG>MapPath</STRONG> method of the <STRONG>Server</STRONG> object to return the physical location of EECustmrs.mdb, based on its relative path. The third statement, which contains two parts, defines the actual connection string. The first part specifies the <EM>data provider</EM>, a component that exposes the database's functionality to OLE DB.  In this case, we're referring to the Microsoft&#174;&nbsp;Jet database engine, which processes all requests for Microsoft Access.  The second part of the connection string simply denotes our data source&#151;EECustmr.mdb.</P>
</ol>

<h3><a name="createthecomponentinstance">Create an Instance of the ADO Connection Object</a></h3>
<ol>
<li>We'll use the ADO <STRONG>Connection</STRONG> object to connect to our database. As always, you need to create an instance of this object in order to use it. Copy and paste the following script command:</li>
<pre> 
<%
  If ScriptLanguagePreference = "JScript" Then
%><%Else%>Set<% End If %> objConnection = Server.CreateObject("ADODB.Connection")  </pre>

<p>If another user has previously completed this portion of the tutorial, this script command will already be in place underneath the "Tutorial Lesson" comment. Paste the copied script over the existing script, or copy an unused version of Database.asp from the Template subdirectory (<%=FilePath%>\template) to the Tutorial directory.</p>

<li>Now you'll need to open a connection to the database. For this we refer to the connection string. Copy and paste the following script command:</li>

<pre>objConnection.Open<%
  If ScriptLanguagePreference = "JScript" Then
%>(strSource)<%Else%> strSource<% End If %> </pre>

<li>Use ADO's <strong>Execute</strong> method to issue a Structured Query Language (SQL) <strong>SELECT</strong> command to the database and store the returned records in a result set (<code>rsCustomersList</code>). Copy and paste the following script commands below the <code>objConnection.Open</code> statement:</li>

<%
  If ScriptLanguagePreference = "JScript" Then
%><pre>rsCustomersList = objConnection.Execute("SELECT * FROM Customers")
%&gt;</pre><%Else%><pre>SQLQuery = "SELECT * FROM Customers"  
Set rsCustomersList = objConnection.Execute(SQLQuery)
%&gt;</pre>



<% End If %>

<%
  If ScriptLanguagePreference = "JScript" Then
%><%Else%><p>You could combine these two lines of script by passing the literal SQL querystring directly to the <strong>Execute</strong> method rather than
assigning it first to the variable <strong>SQLQuery</strong>. When the SQL SELECT is long, however, it makes the script easier to read if you assign the string to a 
variable name, such as <strong>SQLQuery</strong>, and then pass the variable name on to the <strong>Execute</strong> method.</p><% End If %>

</ol>

<h3><a name="displaythereturnedresultset">Display the Returned Result Set</a></h3>

<p>You can think of the result set as a table whose structure is determined by the fields specified in the SQL <strong>SELECT</strong> statement. Displaying the rows returned by the query, therefore, is as easy as performing a loop through the rows of the result set. In this example, the returned data is displayed in HTML table rows.</p>

<ol>

<li>In Database.asp, find the words &#147;<em>Tutorial Lesson - Display ADO Data</em>,&#148; and copy and paste the following VBScript <strong>Do...Loop</strong> statement underneath the comment: </li>
<pre>&lt;% <%
  If ScriptLanguagePreference = "JScript" Then
%>while (!rsCustomersList.EOF) {<%Else%> Do Until rsCustomersList.EOF<% End If %>%&gt;

&lt;TR&gt;
  &lt;TD BGCOLOR="f7efde" ALIGN=center&gt;
    &lt;%= rsCustomersList("ContactFirstName")%&gt; &nbsp;
    &lt;%= rsCustomersList("ContactLastName") %&gt;
  &lt;/TD&gt;
  &lt;TD BGCOLOR="f7efde" ALIGN=center&gt;    
    &lt;a href="mailto:&lt;%= rsCustomersList("ContactLastName")%&gt;"&gt;
    &lt;%= rsCustomersList("ContactLastName")%&gt; &lt;/a&gt;
  &lt;/TD&gt;
  &lt;TD BGCOLOR="f7efde" ALIGN=center&gt;
    &lt;%= rsCustomersList("City")%&gt;
  &lt;/TD&gt;
  &lt;TD BGCOLOR="f7efde" ALIGN=center&gt;
    &lt;%= rsCustomersList("StateOrProvince")%&gt;
  &lt;/TD&gt;
&lt;/TR&gt; 
</pre>

<p>If another user has previously completed this portion of the tutorial, this script command will already be in place. Paste the copied script over the existing script, or copy an unedited copy of Exotic.asp from the Template directory to the Tutorial directory.</p>

<p>The <%=ScriptLanguagePreference%> <%
  If ScriptLanguagePreference = "JScript" Then
%> <strong>while</strong> loop<%Else%> <strong>Do...Loop</strong><% End If %> statement repeats a block of statements while a condition is true. The repeated statements can be script commands 
or HTML text and tags. Thus, each time through the loop, you construct a table row (using HTML) and insert returned data (by using 
script commands).</p>

<li>To complete the loop, use the <strong>MoveNext</strong> method to move the row pointer for the result set down one row. Because this statement still falls within the <strong>Do...Loop</strong> statement, it is repeated until the end of the file is reached. Copy and paste the following lines of script underneath the comment with the words &#147;<em>Tutorial Lesson - Retrieve Next Row</em>&#148;:</li>

<pre>&lt;% 
<%
  If ScriptLanguagePreference = "JScript" Then
%>  rsCustomersList.MoveNext()
}<%Else%>  rsCustomersList.MoveNext 
Loop<% End If %> 
%&gt;</pre>

<li>Save changes to Database.asp as a text file and exit your text editor. Be sure your text editor does not replace the .asp file name extension.</li>

<li>To verify that the script you&#146;ve created works (after which you can return to this tutorial by clicking Back in your browser), point your browser to <a href="http://<%= Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/database.asp"> http://<%= Request.ServerVariables("SERVER_NAME")%>/IISHelp/IIS/Help/Htm/Tutorial/Database.asp</a>.</li>
</ol>

<P>After learning how to create a simple data access script you're probably interested in learning more.  For starters, visit the Microsoft Universal Data Access (UDA) Web Site at <A HREF="http://www.microsoft.com/isapi/redir.dll?prd=mdac" target="_blank">http://www.microsoft.com/data/</A> to learn more about ADO and a host of other UDA technologies.</P>

<p>Now that you've used COM components, you may want to go on to <a href="iiatmd3.asp">Module 3: Writing Your Own  Components</a>.</p>

<hr class="iis" size="1">
<p align=center><a href="/iishelp/common/colegal.htm"><em>&copy; 1997-1999 Microsoft Corporation. All rights reserved.</em></a></p>
</font>
</body>
</html>
