<%@ Language=VBScript EnableSessionState=False %>
<%
  
  ComponentPref =  Request.Form("ComponentPref")     
  If ComponentPref  = "" Then ComponentPref = Request.Cookies("ComponentPreference")

   Select Case ComponentPref
   Case "VB5"
      VB5Checked = "Checked"
   Case "JavaComp"
      JavaChecked = "Checked"
   Case Else
       VB5Checked = "Checked"       
       ComponentPref = "VB5"
   End Select

  Response.Cookies("ComponentPreference") = ComponentPref
  Response.Cookies("ComponentPreference").Expires = "January 1, 2020"
  Response.Cookies("ComponentPreference").Path = "/"


Response.Expires = 0
LessonFile = Request.ServerVariables("SCRIPT_NAME")

  ScriptLanguagePreference = Request.Cookies("ScriptLanguagePreference")

  If ScriptLanguagePreference = "" Then
    ScriptLanguagePreference = Request.QueryString("ScriptLanguagePreference")
    If ScriptLanguagePreference = "" Then
      Response.Redirect "/iishelp/iis/htm/asp/iiselect.asp?LessonFile=" & Server.URLEncode(LessonFile)
    End If
  End If

'Determine the physical path for the current page and then remove the
'name of the file from the path (leaving just the directory).
MainPath = Request.ServerVariables("PATH_TRANSLATED")
Length = Len(MainPath)
i = 0
Do Until (i  = 2)
  Do While (Mid(MainPath, Length, 1) <> "\")
    Length = Length - 1      
  Loop  
i = i + 1
MainPath = left(MainPath, (Length-1)) 
Loop
FilePath = left(MainPath, Length) + "\tutorial"


'Determine the virtual path for the current page and then remove the
'name of the file from the path (leaving just the directory).
MainPath = Request.ServerVariables("PATH_INFO")
 
Length = Len(MainPath)
i = 0
Do Until (i  = 2)
  Do While (Mid(MainPath, Length, 1) <> "/")
    Length = Length - 1      
  Loop  
i = i + 1
MainPath = left(MainPath, (Length-1)) 
Loop
VirtFilePath = left(MainPath, Length) + "/tutorial"

%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html dir=ltr><head><title>Module 3: Writing Your Own Components</title>

<SCRIPT LANGUAGE="JavaScript">
<!--
	TempString = navigator.appVersion
	if (navigator.appName == "Microsoft Internet Explorer"){	
// Check to see if browser is Microsoft
		if (TempString.indexOf ("4.") >= 0){
// Check to see if it is IE 4
			document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/coua.css">');
		}
		else {
			document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/cocss.css">');
		}
	}
	else if (navigator.appName == "Netscape") {						
// Check to see if browser is Netscape
		document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/coua.css">');
	}
	else
		document.writeln('<link rel="stylesheet" type="text/css" href="/iishelp/common/cocss.css">');
//-->
</script> 


<SCRIPT LANGUAGE="VBScript">
<!--
Sub Window_OnLoad()
   Dim frmContents
   On Error Resume Next
   If Not Parent Is Nothing Then
      Set frmContents = Parent.Contents
      If Not frmContents Is Nothing Then
            frmContents.Window.TOCSynch_Click
      End If
   End If
End Sub
//--></SCRIPT>

<META NAME="ROBOTS" CONTENT="NOINDEX"><META HTTP-EQUIV="Content-Type" content="text/html; charset=Windows-1252"></head>

<body bgcolor="#FFFFFF" text="#000000"><font face="Verdana,Arial,Helvetica">
 
<h1><a name="module3writingyourownactivexservercomponents">Module 3: Writing Your Own Components</a></h1>

<p><a href="iiselect.asp?LessonFile=<%= Server.URLEncode(LessonFile)%>"><strong>Choose a scripting language for this lesson.</strong></a></p>

<p>In <a href="iiatmd2.asp">Module 2</a> you familiarized yourself with the components Active Server Pages (ASP) provides, now it's time to think about creating your own components, components that meet your specific needs.</p>

<p>Suppose you want to create an ASP application that provides users with Web access to specific financial functions. Although ASP does not explicitly provide such functions, by creating your own COM component&#151;which you will do in this module&#151;you can add this functionality to your application.<p>

<p>To get started, use the following form to select a component that you would like to learn how to create and implement:</p>

<hr>

<h3><A NAME="H3_22047542">Select a component to create for this lesson:</A></h3>

<form method=post action="iiatmd3.asp#location">
<input type=radio name=ComponentPref value=VB5 <%= VB5Checked  %>>Visual Basic&nbsp;5.0, or later, COM Component<br>
<input type=radio name=ComponentPref value=JavaComp <%= JavaChecked %>>Visual&nbsp;J++&nbsp;1.1, or later, COM Component Written in Java&#153;<br><br>
<input type=submit value="Select">
</form>

<hr>

<p><strong><span style="color: #0000FF"><font color="#0000FF"><a name="location">Important</a></font></span></strong></p>

<ol>
<li>To save and view your work in this module, you require the following: 

<ul>
<li>write and script Web server permissions for the <%= VirtFilePath %> virtual directory on the <%= Request.ServerVariables("SERVER_NAME")%> Web server (with Active Server Pages installed).  For more information, see <a href="/iishelp/iis/htm/core/iiwspsc.htm">Setting Web Server Permissions</a>.</li>


<li>Your Windows account must have NTFS permissions that enable you to read, write, and run programs in the 

<%
  If ComponentPref = "JavaComp" Then
%> <em>DriveLetter</em>:\Winnt\Java directory and its subdirectories, where <em>DriveLetter</em> is the letter mapped to the appropriate drive of the <%= Request.ServerVariables("SERVER_NAME")%> Web server.</li>
<%Else%><em>DriveLetter</em>:\Winnt\System32\Inetsrv\ where you replace <em>DriveLetter</em> with the letter mapped to the appropriate drive of the <%= Request.ServerVariables("SERVER_NAME")%> Web server. (If you did not accept the default installation directory, substitute the name of your installation directory  for \Winnt\System32.)</li>
<% End If %>

</ul>

<li>To complete this module, on the <%= Request.ServerVariables("SERVER_NAME") %> Web server you must have installed: </li>

<ul>
 <li><% If ComponentPref = "JavaComp" Then
%>Microsoft&#174;  Visual&nbsp;J++&#153;&nbsp;1.1, or a later version.
<%Else%>Either the 32-bit version of Microsoft&#174; Visual Basic&nbsp;5.0, or later, Professional Edition or Visual Basic&nbsp;5.0, or later, Enterprise Edition development system.
<% End If %></li>
</ul>

<li>If you have disabled your Web browser's ability to run Java programs, enable this feature  before proceeding with the tutorial.</li>

</ol>

<hr>

<h2><a name="creatingthefinancecomponent">Lesson 1: Creating the <%
  If ComponentPref = "JavaComp" Then
%>Java
<%Else%>COM
<% End If %> Finance Component</a></h2>



<%  If ComponentPref = "JavaComp" Then%>


<p>Suppose that you want to create a Web application that accesses functionality beyond what can be achieved using functions native to <%= ScriptLanguagePreference %>.  Because <%= ScriptLanguagePreference %> does not provide financial functions, you must explicitly define and create a script procedure that encapsulates such functionality.  Such procedures could then be invoked, as needed, from scripts within your application.</p>

<P>Normally, this approach is an adequate solution for encapsulating custom functionality.  However, imagine that you are creating a Web application intended to service thousands of users and that your logic encapsulates proprietary functions?  In this case, encapsulating your functionality in the form of a component is a superior approach.  Components provide better security and performance than scripts.</P> 

<P>In this lesson of the tutorial you will learn how to create and encapsulate as a component a function that computes the future value of an investment based on a fixed interest rate and periodic, fixed payments.</p>


<h3><A NAME="H3_22050303">Start Visual J++</A></h3>

<ol>
<li>Click <strong>Start</strong>, point to <strong>Programs</strong>, then point to <strong>Microsoft Visual&nbsp;J++&nbsp;1.1</strong></li>
<li>Click <strong>Microsoft Developer Studio</strong> in the submenu to run the design environment. </li>
</ol>

<h3><a name="nametheproject">Start and Name a Project</a></h3>

<ol>
<li>Click <strong>File</strong>.</li>
<li>Select <strong>New</strong>.</li>
<li>Click the <strong>Project</strong> tab.</li>
<li>Select <strong>Java Project</strong>.</li>
<li>In the <strong>Project Name</strong> box, type Finance, then click <strong>OK</strong>.</li>
</ol>

<h3><A NAME="H3_22050969">Add the Finance Class to the Project</A></h3>

<ol>
<li>In the <strong>Insert</strong> menu, choose <strong>New Class</strong>.</li>
<li>In the <strong>Name</strong> box, type Finance, then click <strong>OK</strong>.   The following should appear in the text editor:</li>

<pre>class Finance
{


}
</pre>

<p><strong>Note</strong>&nbsp;&nbsp;&nbsp;The Class name must be the same as the Project name for a Java server component.</p>
</ol>

<h3><A NAME="H3_22051481">Add the CalcFV Function to the Finance Class</A></h3>

<ol>	
<li>Select the <strong>ClassView</strong> tab (selected by default).</li>
<li>Expand the <strong>Finance Classes</strong> item in the tree control.</li>
<li>Right-click <strong>Finance</strong> class and select <strong>Add Method</strong>.</li>
<li>In the <strong>Return Type</strong> box, type <strong>public double</strong>.</li>
<li>In the <strong>Method declaration</strong> box, copy and paste the following: </li>

<code>CalcFV(double dblRate, double dblNPer, double dblPMT, double dblPv, boolean bType)</code>  

<p>With this declaration, you define the a finance function, belonging to the Finance class, that computes the future value of an investment.<br>

<li>Click <strong>OK</strong>.  The following appears in the Visual J++ text editor:</li>

<pre>class Finance
{
  public double CalcFV(
    double dblRate, 
    double dblNPer, 
    double dblPMT, 
    double dblPv, 
    boolean bType)
    {


    }

}
</pre>
 
<li>Within the innermost set of brackets, copy and paste the following Java code into the text editor:</li>

<pre>double dblRet, dblTemp, dblTemp2, dblTemp3;

if (dblRate == 0.0)
{
 dblRet = -dblPv - dblPMT * dblNPer;
}
else
{
dblTemp = (bType ? 1.0 + dblRate : 1.0);
dblTemp3 = 1.0 + dblRate;
dblTemp2 = Math.pow(dblTemp3, dblNPer);  
dblRet = -dblPv * dblTemp2 - dblPMT * dblTemp * (dblTemp2 - 1.0) / dblRate;
}

return dblRet;
</pre>

<p>Don't be intimidated by this code, it simply defines the mathematical equation (in Java's syntax) necessary for computing the future value of an investment.  If you are interested, you can find information about this commonly used equation in almost any financial mathematics or accounting text book.</p>

<p><strong>Note</strong>&nbsp;&nbsp;&nbsp;Java is case sensitive, so if you decide to type the previous lines of code into the text editor, be sure to type Java syntax and variables exactly as shown.</p>
	
</ol>

<h3><A NAME="H3_22053702">Build the Finance Component</A></h3>

<ol>
<li>In the <strong>Build</strong> menu, Select <strong>Build Finance</strong>. </li>
<li>In the <strong>Build</strong> window (located below the <strong>ClassView</strong> and text editing windows) make sure the build process has not generated any errors or warnings.</li>
</ol>

<h3><A NAME="H3_22054061">Copy the Finance Component to the Trustlib directory</A></h3>

<ol>
<li>Click the Windows <strong>Start</strong> button, point to <strong>Programs</strong>, then click <strong>Windows Explorer</strong>.</li>
<li>Copy the Finance.class component from the Program Files\DevStudio\MyProjects\Finance\ directory to the <%= Request.ServerVariables("SERVER_NAME") %> Web server's Winnt\Java\Trustlib directory.</li>
</ol>

<h3><a name="registerthefinanceservercomponent">Register the Finance Java Class</a></h3>

<p>You must register the Finance Java class to make it callable by JScript and all of the other OLE-compatible languages on your computer.</p>

<ol>
<li>Open a command-prompt window.</li>
<li>Type <strong>cd <em>Drive Letter</em>:\<%= Request.ServerVariables("SERVER_NAME")%>\Program Files\DevStudio\VJ\Bin\</strong> at the command prompt, where <em>DriveLetter</em> is the letter mapped to the appropriate drive on your computer. (If you did not accept the default installation directory, substitute the name of your installation directory  for \Program Files\DevStudio\VJ\Bin\.)</li>
<li>Press <STRONG>Enter</STRONG>.</li>
<li>Type <strong>javareg /register /class:Finance /progid:MS.Finance.Java</strong>.</li>
<li>Press <STRONG>Enter</STRONG>.</li>
<li>Click the <strong>OK</strong> button when a dialog box appears that says <strong>Successfully Registered Java class "Finance" as CLSID</strong>.</li>
<li>Close the command-prompt window.</li>
</ol>

<%Else%>
<p>Suppose that you want to create a Web application that accesses functionality beyond what can be achieved using functions native to <%= ScriptLanguagePreference %>.  Because <%= ScriptLanguagePreference %> does not provide financial functions, you must explicitly define and create a script procedure that encapsulates such functionality.  Such procedures could then be invoked, as needed, from scripts within your application.</p>

<P>Normally, this approach is an adequate solution for encapsulating custom functionality.  However, imagine that you are creating a Web application intended to service thousands of users and that your logic encapsulates proprietary functions?  In this case, encapsulating your functionality in the form of a component is a superior approach.  Components provide better security and performance than scripts.</P> 

<P>In this lesson of the tutorial you will learn how to create and encapsulate as a component a function that computes the future value of an investment based on a fixed interest rate and periodic, fixed payments.</p>
<br>

<h3><a name="startvisualbasic">Start Visual Basic</a></h3>

<ol>
<li>Click <strong>Start</strong>, point to <strong>Programs</strong>, then point to <strong>Microsoft Visual Basic&nbsp;5.0</strong>.</li>
<li>Click <strong>Visual Basic&nbsp;5.0</strong> in the submenu to run the design environment. </li>
</ol>

<h3><a name="nametheproject">Start and Name a Project</a></h3>

<ol>
<li>In the <strong>New Project</strong> dialog box, double-click <strong>ActiveX DLL</strong>.</li>
<li>On the <strong>Project </strong> menu, click <strong>Project1 Properties</strong>. </li>
<li>On the <strong>General</strong> property sheet, in the <strong>Project Name</strong> box, type MS. </li>
<li>Select <strong>Unattended Execution</strong>. </li>

<p><strong>Note</strong>&nbsp;&nbsp;&nbsp;You select this option so that the project will run without user interaction and has no user interface elements.</p>

<li>Click <strong>OK</strong>.</li>
</ol>

<p>The project is now named MS. Later, you will reference the Finance server component as <code>MS.Finance</code> from an ASP script.</p>

<h3><a name="addthefinanceclasstotheproject">Add the Finance Class to the Project</a></h3>

<p>In Visual Basic, to create a component with a set of functionality you can call, you define a <em>class</em>. A class groups methods and properties.  In your project, it will be the place within which you specify your finance methods.</p>

<ol>
<li>Press F4 to open the <strong>Properties</strong> window for the class module, then double-click the <strong>Name</strong> property and type <strong>Function</strong>, then press <STRONG>Enter</STRONG>.</li>
<li>Double-click <strong>Instancing</strong>.</li>
<li>Click the arrow, then select <strong>5 - MultiUse</strong>.</li>
</ol>

<h3><a name="learnmoreaboutvisualbasicfinancefunctions">Learn More About Visual Basic Finance Functions</a></h3>

<p>The Visual Basic Help system describes available financial functions.</p>

<ol>
<li>Click <strong>Help</strong>.</li>
<li>Select <strong>Microsoft Visual Basic Help Topics</strong>.</li>
<li>Select the <strong>Index</strong> tab, then type <strong>financial functions</strong> as the word to look for.</li>
<li>Double-click the <strong>financial functions</strong> index entry. </li>
<li>Click <strong>FV Function</strong> to learn more about it.</li>
<li>Close the <strong>Visual Basic Help</strong> dialog box when you have finished reviewing the finance functions.</li>
</ol>

<h3><a name="addthecalcfvfunctiontothefinanceclass">Add the CalcFV Function to the Finance Class</a></h3>

<p>The Finance server component does require some programming code. This code will make the Visual Basic built-in future value function available to languages making use of your component.</p>

<p>Copy and paste the following lines into the Finance class code window:</p>

<pre>Public Function CalcFV(rate, nper, pmt, Optional pv, Optional whendue) 
CalcFV = FV(rate, nper, pmt, pv, whendue)
End Function</pre>

<h3><a name="addthecomponentsentrypoint">Add the Component&#146;s Entry Point</a></h3>

<p>All server components require an entry (starting) point. This is the code that will be called when the object is first made available to a language. In VBScript, when you use <strong>Server.CreateObject</strong>, an instance is created of an object. When the <strong>Server.CreateObject </strong>statement is executed, the <strong>Sub Main</strong> procedure in a server component (that is, one created with Visual Basic) is called.</p>

<p>Your finance component does not have to do anything special to initialize itself when it is called. For that reason, you can provide an empty (no Visual Basic statements) <strong>Sub Main</strong> procedure.</p>

<ol>
<li>In the <strong>Project </strong>menu, select <strong>Add Module</strong>.</li>
<li>In the <strong>Module&nbsp;1 </strong>dialog box, double-click the module icon.</li>
<li>In the Module 1 code window, type <strong>Sub Main</strong>.</li>
<li>Press <STRONG>Enter</STRONG>.</li>
</ol>

<p>This automatically enters the following code:</p>

<pre>Sub Main()
End Sub</pre> 

<h3><a name="savethefinanceproject">Save the Finance Project</a></h3>

<p>When you save your work, you will be asked to save all three parts of the Visual Basic project. These include the project file, the class module, and the code module.</p>

<ol>
<li>Open the <strong>File </strong>menu.</li>
<li>Select <strong>Save Project</strong>.</li>
<li>In the <strong>File name</strong> text box, type Finance.  Select the following path on the <%= Request.ServerVariables("SERVER_NAME")%> Web server: <strong><em>DriveLetter</em>:\Winnt\System32\Inetsrv\</strong> where <em>DriveLetter</em> is the letter mapped to the appropriate drive. (If you did not accept the default installation directory, substitute the name of your installation directory  for \Winnt\System32.)</li>
<li>Click the <strong>Save</strong> button.</li>
<p>If a previous user has completed this portion of the tutorial, a message will appear stating that the file already exists. Save your version of the file in place of the older version.</p>
<li>Double-click the value <strong>Project1</strong> in the <strong>File name</strong> text box to select it.</li>
<li>Type the name <strong>Finance</strong> for the Project file (.vbp).</li>
<li>Click the <strong>Save</strong> button to save the project.</li>
<p>If a previous user has completed this portion of the tutorial, a message will appear stating that the file already exists. Save your version of the file in place of the older version.</p>
</ol>

<h3><a name="makethecomponentaninprocesscomponent">Make the Component an In-Process Component</a></h3>

<p>Visual Basic allows you to create in-process COM components (formerly called OLE Automation Servers) and out-of-process COM components. An <em>in-process</em> COM component is a dynamic-link library (file name extension .dll) that is loaded by the calling process. An <em>out-of-process</em> COM component is an executable (file name extension .exe) that runs as a separate process from the calling application. Because in-process components are in the same process space as the calling program, they provide better performance than out-of-process components.</p>

<p>To make the Finance server component an in-process COM component</p>

<ol>
<li>Open the <strong>File</strong> menu.</li>
<li>Select <strong>Make Finance.dll</strong>.</li>
<li>Click the <strong>Options</strong> button.</li>
<li>Select the <strong>Auto Increment</strong> check box. </li>
<li>Click <strong>OK</strong>.</li>
<li>Type <strong><em>DriveLetter</em>:\<%= Request.ServerVariables("SERVER_NAME")%>\Winnt\System32\Inetsrv\Finance</strong> where <em>DriveLetter</em> is the letter mapped to the appropriate drive on your computer. (If you did not accept the default installation directory, substitute the name of your installation directory  for \Winnt\System32.)<br>
If a previous user has completed this portion of the tutorial, a message will appear stating that the file already exists. Save your version of the file in place of the older version.</li>
<li>Exit Visual Basic.</li>
</ol>

<h3><a name="registerthefinanceservercomponent">Register the Finance Server Component</a></h3>

<p>All server components must be registered. Windows makes use of the system registry to keep track of available server components. By registering the Finance server component, you make it callable by VBScript and all of the other OLE-compatible languages on your computer.</p>

<ol>
<li>Open a command-prompt window.</li>
<li>Type <strong>cd <em>Drive Letter</em>:\<%= Request.ServerVariables("SERVER_NAME")%>\Winnt\System32\Inetsrv</strong> at the command prompt, where <em>DriveLetter</em> is the letter mapped to the appropriate drive on your computer. (If you did not accept the default installation directory, substitute the name of your installation directory  for \Winnt\System32.)</li>
<li>Press <STRONG>Enter</STRONG>.</li>
<li>Type <strong>regsvr32 Finance.dll</strong>. </li>
<li>Press <STRONG>Enter</STRONG>.</li>
<li>Click <strong>OK</strong> when a dialog box appears that says <strong>DllRegisterServer in finance.dll succeeded</strong>.</li>
<li>Close the command-prompt window.</li>
</ol>

<hr>

<% End If %>

<h2> <a name="callingthefinancecomponentfromascript">Lesson 2: Calling the Finance Component from a Script</a></h2>

<p>To test the component, you can call the component from Active Server Pages (ASP), Visual&nbsp;Basic, Microsoft&#174;&nbsp;Office products that use Visual&nbsp;Basic for Applications, or any other OLE Automation controller.</p>

<p>To call the Finance server component from Active Server Pages by using <%=ScriptLanguagePreference%>, you can use an HTML form as input to calculate the future 
value of a person&#146;s savings plan.</p>

<h3><a name="thehtmlform">The HTML Form</a></h3>

<p>An HTML form will be used to gather values that describe a savings plan. These values are assigned variables that are made available to an 
ASP script as part of the <strong>Request</strong> object. You can reference a value from an HTML form. For example, the annual percentage 
rate entered on a form can be referenced by a script using <strong><code>Request("APR")</code></strong>. The HTML tag <code>&lt;INPUT TYPE=TEXT NAME=APR&gt;</code> provides the input field necessary to enter a value.</p>

<p>To send the form to a Microsoft Web server running ASP, the user clicks a <STRONG>Submit</STRONG> button. The <STRONG>Submit</STRONG> button calls the page indicated by the <code>ACTION</code> property of the HTML form tag. The HTML tag for the <STRONG>Submit</STRONG> button (<code>&lt;INPUT TYPE=SUBMIT VALUE=" Calculate Future Value "&gt;</code>) uses the value for <code>ACTION</code> from the HTML form tag (<code>&lt;FORM METHOD=POST 
ACTION="Finance<%If ScriptLanguagePreference = "JScript" Then
%>j<%Else%><% End If %>.asp"&gt;</code>) to call the ASP page Finance<%
  If ScriptLanguagePreference = "JScript" Then
%>j<%Else%><% End If %>.asp.</p>
<p>We have created the form for you. Use your text editor to open the file FVform.asp in the <%= Request.ServerVariables("SERVER_NAME")%> Web server's Tutorial directory (<%= FilePath %>).</p>

<h3><a name="thescript">The Script</a></h3>

<p>You use <%=ScriptLanguagePreference%> to call your Finance server component. The script starts by validating the inputs from the HTML form and assigning default values for any values that were not entered on the form. <%
  If ScriptLanguagePreference = "JScript" Then
%>A custom function called <strong>IsNumeric</strong> tests whether or not a numeric (valid) 
value was entered for each of the boxes on the HTML form. <%Else%>The VBScript <strong>IsNumeric</strong> function tests whether or not a numeric (valid) 
value was entered for each of the boxes on the HTML form.</p>
<% End If %>

<%
  If ComponentPref = "JavaComp" Then
%><p><strong>Server.CreateObject</strong> creates an instance of (that is, makes usable) your Finance component named <code>MS.Finance.Java</code>. After creating an instance 
of the component, you can make use of its methods and properties.  The script line immediately following 
<strong>Server.CreateObject</strong><%Else%>
<p><strong>Server.CreateObject</strong> creates an instance of (that is, makes usable) your Finance component named <code>MS.Finance</code>. After creating an instance 
of the component, you can make use of its methods and properties.  The script line immediately following 
<strong>Server.CreateObject</strong><% End If %> uses the <strong>CalcFV</strong> method to calculate a savings plan's future value. The result of this calculation appears on the the browser of the user requesting the information.</p>

<p>To view the script, use a text editor to open the file <%
  If ScriptLanguagePreference = "JScript" Then
%>Financej.asp



<%Else%>Finance.asp



<% End If %> in the Tutorial directory (<%= FilePath %>).</p>

<h3><a name="usingyourbrowsertorunthetest">Using Your Browser to Run the Test</a></h3>

<p>To run the <%
  If ScriptLanguagePreference = "JScript" Then
%>Financej
<%Else%>Finance
<% End If %> ASP page, open the  FVform.asp  file, which  renders a form and then calls the <%
  If ScriptLanguagePreference = "JScript" Then
%>Financej.asp<%Else%>Finance.asp<% End If %> script to calculate the future value of the savings plan specified on the form.</p>

<ol>
<li>Open FVform.htm by pointing  your browser to <a href="http://<%=Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/FVform.asp?ScriptLanguagePreference=<%=ScriptLanguagePreference%>&ComponentPref=<%=ComponentPref%>">http://<%=Request.ServerVariables("SERVER_NAME")%>/iishelp/iis/htm/tutorial/FVform.asp</a>.</li>
<li>Enter values for the form inputs in the <strong>Savings Plan</strong> form.</li>
<li>Click the <strong>Calculate Future Value</strong> button. The value of your savings plan should appear.</li>
</ol>

<p>In a relatively short time you have created a useful <%
  If ComponentPref = "JavaComp" Then
%>Java<%Else%>COM<% End If %> component. If you need access to other financial functions, you can implement other financial functions <%
  If ComponentPref = "JavaComp" Then
%>with Visual J++<%Else%>built into Visual Basic<% End If %> as additional methods of your Finance server component. We encourage you to experiment and come up with creative ways to utilize your own <%If ComponentPref = "JavaComp" Then%>Java<%Else%>COM<% End If %> components.  Soon, you will find that there is virtually no limit to the Web applications you can develop using components.</p>

<hr class="iis" size="1">
<p align=center><a href="/iishelp/common/colegal.htm"><em>&copy; 1997-1999 Microsoft Corporation. All rights reserved.</em></a></p>
</font>
</body>
</html>
